function TimelineMenu() {
	var _this = this;
	var Selector = {};
	var imgPath = {
		normal: 'framework/images/ui_timeline-inactive.svg',
		hover: 'framework/images/ui_timeline-hover.svg',
		current: 'framework/images/ui_timeline-active.svg',
		complete: 'framework/images/ui_timeline-complete.svg',
		
	}
	_this.start = function (_obj) {
		Selector = {
			CLASS_NAME: 'timeline-menu',
			ACTIVITY_CONTAINER: '#timeline-menu-container',
			MENU_CONTAINER: '.timeline-activity-panel',
			XML_NODE: APP.globalXmlsObj.globalXML,
			FONT_ICON_CLASS_OBJ: {				
				plus: 'icon-plus',
				minus: 'icon-minus'
			},
			
			MODE:'',
			CLICK_ARRAY:[],
			ON_INIT: null,
			ON_COMPLETE: null,
			ON_CLICK: null,
			isCompleted: false,
			userData:null
		};
		Selector = $.extend(Selector, _obj);
		initTemplate();
	}
	_this.updateAllButtonStatus = function(){
		updateAllButtonStatus();
	}
	function initTemplate() {
		if(Selector.XML_NODE == null){
			console.warn('XML NOT FOUND...')
			return;
		}
		Selector.isCompleted = false;
		$(Selector.ACTIVITY_CONTAINER).addClass(Selector.CLASS_NAME).addClass(Selector.MODE);
		createContent();					
		updateStatus();
	}

	function createContent(){		
		var str ='';	
		
			/* 1 */str +='<div class="inner-panel">';	
				str +='<div class="scroll-parent">';
					str +='<div class="scrollable">';					
						var menuXmlObj = Selector.XML_NODE.menu[0];		
						for (var i=0; i<menuXmlObj.module.length; i++){
							var curr = menuXmlObj.module[i];
							if(curr.hideOnMenu == 'true'){
								continue;
							}
							var statusClass="not-attempted"
							var modStatus = APP.courseDataObj.getModuleStatus(i);
							if(modStatus == '1'){
								statusClass = "incomplete"
							}
							if(modStatus == '2'){
								statusClass = "complete"
							}
							var mref = 'mod-'+i;
							var mtxt = curr.title[0].Text;
							var visibleClass = '';
							if(mtxt == null || mtxt == ''){
								visibleClass = 'no-title'
							}
							var overText = '';
							if(curr.overText){				
								overText = curr.overText[0].Text;
							}
							var extraText = '';
							if(curr.extraText){				
								extraText = curr.extraText[0].Text;
							}
							
							/* 1a */str += '<div id="'+mref+'" class="mod-btn-block '+mref+'  '+statusClass+' '+visibleClass+'">';
									str+='<a class="btn with-img module-btn" title="'+overText+'" data-modid="'+i+'" href="javascript:void(0)">';
										str += '<img class="img-tag normal-img" src="'+imgPath.normal+'" alt="">';
										str += '<img class="img-tag complete-img" src="'+imgPath.complete+'" alt="">';
										str += '<img class="img-tag current-img" src="'+imgPath.current+'" alt="">';
										str += '<img class="img-tag hover-img" src="'+imgPath.hover+'" alt="">';
										str+= '<span class ="btn-txt display-cell v-center center" >'+mtxt+'</span>';	
									str += '</a>';
									str += '<div class="extra-div font-1"><p>'+extraText+'</p></div>';
							/* 1a */str += '</div>';
						}
					str +='</div>';
				str +='</div>';
			/* 1 */str +='</div>';
			
		$(Selector.ACTIVITY_CONTAINER).find('.dynamic-panel').html(str);		
		
		addTemplateEvent();			
		updateAllButtonStatus();
	}

	function addTemplateEvent() {
		$(Selector.ACTIVITY_CONTAINER).find('.module-btn').on('click', function(e){
			var parentBlock = $(this).parents('.mod-btn-block');			
			if(parentBlock.hasClass('locked') || $(this).hasClass('disabled')){return false;};
			e.stopPropagation();
			APP.commonFunObj.playSoundEffect({name: 'clicked'});
			var id = parentBlock.attr('id');
			var modId = parseInt($(this).data('modid'));
					
			APP.navData.moduleId = modId;
			APP.navData.topicId = 0;
			APP.navData.screenId = 0;
			APP.navigationObj.loadScreen();
		});
		$(Selector.ACTIVITY_CONTAINER).find('.topic-btn').on('click', function(){
				if($(this).hasClass('locked') || $(this).hasClass('disabled') || $(this).hasClass('current')){return false;};
			
				$(Selector.ACTIVITY_CONTAINER).find('.topic-btn').removeClass('current');
				
				updateStatus();			
				APP.navData.moduleId = $(this).data('modid');
				APP.navData.topicId = $(this).data('topicid');
				APP.navData.screenId = 0;
				APP.navigationObj.loadScreen();
				
		})
		$(Selector.ACTIVITY_CONTAINER).find('.screen-btn').on('click', function(e){
			if($(this).parents('.screen-btn-block').hasClass('locked') || $(this).hasClass('disabled')){return false;};	
			e.stopPropagation();
			APP.commonFunObj.playSoundEffect({name: 'clicked'});
			APP.navData.moduleId = $(this).data('modid');
			APP.navData.topicId = $(this).data('topicid');
			APP.navData.screenId = $(this).data('screenid');			
			APP.navigationObj.loadScreen();			
		})
		
	}
		
	function createScreenBlock(_modId){
		var str = '';
			
			var curr = Selector.XML_NODE.menu[0].module[_modId];
			var mtxt = _modId+'. '+curr.title[0].Text;			
			var subTopicXmlObj = curr.topic;
			for (var j=0; j<subTopicXmlObj.length; j++){
				var currSubTopic = subTopicXmlObj[j];
				if(currSubTopic.hideOnMenu == 'true'){
					continue;
				}
				str+='<div class="sub-topic-panel sub-topic-panel-'+_modId+'_'+j+'">';
				var subTopicStatusClass="not-attempted"
				var subTopicStatus = APP.courseDataObj.getTopicStatus(_modId, j);
				if(subTopicStatus == '1'){
					subTopicStatusClass = "incomplete"
				}
				if(subTopicStatus == '2'){
					subTopicStatusClass = "complete"
				}
				for (var k=0; k<subTopicXmlObj[j].screen.length; k++){
					var currScreen = subTopicXmlObj[j].screen[k];
					if(currScreen.hideOnMenu == 'true'){
						continue;
					}
					
					var screenStatusClass="not-attempted"
					var screenStatus = APP.courseDataObj.getScreenStatus({moduleId: _modId, topicId: j, screenId: k});
					if(screenStatus == '1'){
						screenStatusClass = "incomplete"
					}
					if(screenStatus == '2'){
						screenStatusClass = "complete"
					}
					var sref = 'screen-'+_modId+'_'+j+'_'+k;
					var stxt = currScreen.title[0].Text;
					var svisibleClass = '';
					if(stxt == null || stxt == ''){
						svisibleClass = 'no-title'
					}
					/* 3 */str += '<div id="'+sref+'" class="screen-btn-block '+sref+' '+screenStatusClass+' '+svisibleClass+'">';
							str+='<a class="btn screen-btn" data-modid="'+_modId+'" data-topicid="'+j+'" data-screenid="'+k+'" href="javascript:void(0)">';
								str += '<div class="indicator indicator-cell display-cell v-center center"><span class="font-icon status-icon"></span></div>';
								
							str += '</a>';
					/* 3 */str += '</div>';
					
				}
				str+='</div>';
			}			
		return str;
	}
	function updateWidth(){
		var menuContainer = $(Selector.ACTIVITY_CONTAINER).find(Selector.MENU_CONTAINER);	
		//.scroll-parent .scrollable
		var wd = 0;
		menuContainer.find('.scrollable').find('.mod-btn-block').each(function(inx){

			wd += $(this).outerWidth(true);
			
		})
		menuContainer.find('.scrollable').css('width', wd+'px');
	}
	function updateTemplateLayout() {
		updateWidth();
	}
	
	$(document).on(APP.eventObj.ON_CUSTOM_RESIZE, function (e) {
		updateTemplateLayout();
	});
	function updateAllButtonStatus(){
		var menuXmlObj = Selector.XML_NODE.menu[0];
		
		var menuContainer = $(Selector.ACTIVITY_CONTAINER).find(Selector.MENU_CONTAINER);		
		for (var i=0; i<menuXmlObj.module.length; i++){
			var curr = menuXmlObj.module[i];
			if(curr.hideOnMenu == 'true'){
				continue;
			}
			var statusClass="not-attempted"
			var modStatus = APP.courseDataObj.getModuleStatus(i);
			if(modStatus == '1'){
				statusClass = "incomplete"
			}
			if(modStatus == '2'){
				statusClass = "complete"
			}
			var currModClass="";
			if(APP.navData.moduleId == i){
				currModClass = "current-mod";
			}
			menuContainer.find('.mod-'+i).removeClass('not-attempted incomplete complete current-mod').addClass(statusClass).addClass(currModClass);
			menuContainer.find('.mod-'+i).find('.indicator').find('.status-icon').attr('class', 'font-icon status-icon');
			var subTopicXmlObj = curr.topic;
			for (var j=0; j<subTopicXmlObj.length; j++){
				var currSubTopic = subTopicXmlObj[j];
				if(currSubTopic.hideOnMenu == 'true'){
					continue;
				}				
				var subTopicStatusClass="not-attempted"
				var subTopicStatus = APP.courseDataObj.getTopicStatus(i, j);
				if(subTopicStatus == '1'){
					subTopicStatusClass = "incomplete"
				}
				if(subTopicStatus == '2'){
					subTopicStatusClass = "complete"
				}
				var currTopicClass="";
				if(APP.navData.moduleId == i && APP.navData.topicId == j){
					currTopicClass = "current-topic";
				}
				menuContainer.find('.topic-'+i+'_'+j).removeClass('not-attempted incomplete complete current-topic').addClass(subTopicStatusClass).addClass(currTopicClass);
				menuContainer.find('.topic-'+i+'_'+j).find('.indicator').find('.status-icon').attr('class', 'font-icon status-icon');
				var screenXmlObj = currSubTopic.screen;
				for (var k=0; k<screenXmlObj.length; k++){
					var currScreen = screenXmlObj[k];
					if(currScreen.hideOnMenu == 'true'){
						continue;
					}					
					var screenStatusClass="not-attempted"
					var screenStatus = APP.courseDataObj.getScreenStatus({moduleId: i, topicId: j, screenId: k});
					if(screenStatus == '1'){
						screenStatusClass = "incomplete"
					}
					if(screenStatus == '2'){
						screenStatusClass = "complete"
					}
					var currScreenClass="";
					if(APP.navData.moduleId == i && APP.navData.topicId == j && APP.navData.screenId == k){
						currScreenClass = "current-screen";
					}
					menuContainer.find('.screen-'+i+'_'+j+'_'+k).removeClass('not-attempted incomplete complete current-screen').addClass(screenStatusClass).addClass(currScreenClass);
					menuContainer.find('.screen-'+i+'_'+j+'_'+k).find('.indicator').find('.status-icon').attr('class', 'font-icon status-icon');
				}
			}
		}
		updateWidth();
		updateModButtonStatus();
		updateTopicButtonStatus();
		updateScreenButtonStatus();
	}
	function updateModButtonStatus(){	
		var cheatMode = APP.configObj.cheatMode;	
		var menuContainer = $(Selector.ACTIVITY_CONTAINER).find(Selector.MENU_CONTAINER);
		if(APP.configObj.menu.lockMenu == true && !cheatMode){
			menuContainer.find('.mod-btn-block.not-attempted').addClass('locked');
			menuContainer.find('.mod-btn-block').eq(0).removeClass('locked');
			menuContainer.find('.mod-btn-block.complete').next().removeClass('locked');
		}
		//--indicator changes	
		menuContainer.find('.mod-btn-block.locked').find('.indicator .status-icon').addClass(APP.iconObj.locked);	
		menuContainer.find('.mod-btn-block.not-attempted:not(.locked)').find('.indicator .status-icon').addClass(APP.iconObj.notAttempted);
		
		menuContainer.find('.mod-btn-block.incomplete').find('.indicator .status-icon').addClass(APP.iconObj.incomplete);
		menuContainer.find('.mod-btn-block.complete').find('.indicator .status-icon').addClass(APP.iconObj.complete);

	}
	function updateTopicButtonStatus(){
		var cheatMode = APP.configObj.cheatMode;
		var subMenuContainer = $(Selector.ACTIVITY_CONTAINER).find(Selector.MENU_CONTAINER);
				
		//--indicator changes
		subMenuContainer.find('.topic-btn-block.locked').find('.indicator .status-icon').addClass(APP.iconObj.locked);
		subMenuContainer.find('.topic-btn-block.not-attempted').find('.indicator .status-icon').addClass(APP.iconObj.notAttempted);
		subMenuContainer.find('.topic-btn-block.incomplete').find('.indicator .status-icon').addClass(APP.iconObj.incomplete);
		subMenuContainer.find('.topic-btn-block.complete').find('.indicator .status-icon').addClass(APP.iconObj.complete);
		
	}
	function updateScreenButtonStatus(){
		var cheatMode = APP.configObj.cheatMode;
		var subMenuContainer = $(Selector.ACTIVITY_CONTAINER).find(Selector.MENU_CONTAINER);
				
		//--indicator changes
		subMenuContainer.find('.screen-btn-block.locked').find('.indicator .status-icon').addClass(APP.iconObj.locked);
		subMenuContainer.find('.screen-btn-block.not-attempted').find('.indicator .status-icon').addClass(APP.iconObj.notAttempted);
		subMenuContainer.find('.screen-btn-block.incomplete').find('.indicator .status-icon').addClass(APP.iconObj.incomplete);
		subMenuContainer.find('.screen-btn-block.complete').find('.indicator .status-icon').addClass(APP.iconObj.complete);
		
	}
	function updateStatus() {	
		if (Selector.ON_CLICK) {			
			Selector.ON_CLICK();
		}
		Selector.isCompleted = true;		
		if (Selector.isCompleted) {
			screenCompleted();
		}
	}

	function screenCompleted() {
		if (Selector.ON_COMPLETE) {
			Selector.ON_COMPLETE();
		}

	}
}